[U-Boot] [PATCH 1/3] scripts: add scripts/gnu_make to not hard-code make command

Masahiro Yamada yamada.m at jp.panasonic.com
Thu Jul 17 11:18:00 CEST 2014


U-Boot is expected to be built on various platforms
but makefiles are written for GNU Make.

We should keep in mind that the command 'make' is not always GNU Make.

For example, on Linux, people generally do:

  make <board>_config; make

But FreeBSD folks do

  gmake <board>_config; gmake

(The command 'make' on FreeBSD is BSD Make, not GNU Make)

It is not a good idea to hard-code the command name 'make'
in MAKEALL or buildman.

Instead, they should call the make command via this helper script
to make sure it is GNU Make.

Signed-off-by: Masahiro Yamada <yamada.m at jp.panasonic.com>
---

 scripts/gnu_make | 30 ++++++++++++++++++++++++++++++
 1 file changed, 30 insertions(+)
 create mode 100755 scripts/gnu_make

diff --git a/scripts/gnu_make b/scripts/gnu_make
new file mode 100755
index 0000000..2eeafbb
--- /dev/null
+++ b/scripts/gnu_make
@@ -0,0 +1,30 @@
+#!/bin/sh
+#
+# Call GNU Make
+#
+# U-Boot is supposed to be built on various platforms.
+# One problem is that the command 'make' is not always GNU Make.
+# (For ex. the command name for GNU Make on FreeBSD is usually 'gmake'.)
+# It is not a good idea to hard-code the command name 'make'
+# in scripts where where GNU Make is expected.
+# In that case, call this helper script to make sure to invoke GNU Make.
+#
+# SPDX-License-Identifier:	GPL-2.0+
+#
+
+gnu_make=
+
+for m in make gmake
+do
+	if $m --version 2>/dev/null | grep -q GNU; then
+		gnu_make=$m
+		break
+	fi
+done
+
+if [ -z "$gnu_make" ]; then
+	echo "GNU Make not found" >&2
+	exit 1
+fi
+
+$gnu_make "$@"
-- 
1.9.1



More information about the U-Boot mailing list